# https://bugzilla.redhat.com/show_bug.cgi?id=995136#c12
%global _dwz_low_mem_die_limit 0
%global provider        github
%global provider_tld    com
%global project         coreos
%global repo            fleet

%global import_path     %{provider}.%{provider_tld}/%{project}/%{repo}

Name:		%{repo}
Version:	0.9.1
Release:	0.1%{?dist}
Summary:	A Distributed init System
License:	ASL 2.0
URL:		https://%{import_path}
Source0:	https://%{import_path}/archive/%{name}-%{version}.tar.gz
Source1:	%{name}.service
Source2:	%{name}.conf
Source3:	%{name}.socket
ExclusiveArch:  %{ix86} x86_64 %{arm}
BuildRequires:	golang >= 1.3.3
BuildRequires:	systemd
BuildRequires:  etcd
Requires:       etcd
Requires(pre):	shadow-utils
Requires(post): systemd
Requires(preun): systemd
Requires(postun): systemd

%description
A Distributed init System

%prep
%setup -qn %{name}-%{version}

find . -name "*.go" \
       -print |\
       xargs sed -i 's/github.com\/coreos\/fleet\/Godeps\/_workspace\/src\///g'

%build
# Make link for etcd itself
mkdir -p src/github.com/coreos
ln -s ../../../ src/github.com/coreos/fleet

export GOPATH=$(pwd):%{gopath}:$GOPATH:$(pwd)/Godeps/_workspace
# *** ERROR: No build ID note found in /.../BUILDROOT/etcd-2.0.0-1.rc1.fc22.x86_64/usr/bin/etcd
function gobuild { go build -a -ldflags "-B 0x$(head -c20 /dev/urandom|od -An -tx1|tr -d ' \n')" -v -x "$@"; }

gobuild -o bin/fleetd %{import_path}/fleetd
gobuild -o bin/fleetctl %{import_path}/fleetctl


%install
install -D -p -m 0755 bin/%{name}d %{buildroot}%{_bindir}/%{name}d
install -D -p -m 0755 bin/%{name}ctl %{buildroot}%{_bindir}/%{name}ctl
install -D -p -m 0644 %{SOURCE1} %{buildroot}%{_unitdir}/%{name}.service
install -D -p -m 0644 %{SOURCE3} %{buildroot}%{_unitdir}/%{name}.socket
install -d -m 0755 %{buildroot}%{_sysconfdir}/%{name}
install -m 644 -t %{buildroot}%{_sysconfdir}/%{name} %{SOURCE2}

# And create /var/lib/etcd
install -d -m 0755 %{buildroot}%{_sharedstatedir}/%{name}

%pre
getent group %{name} >/dev/null || groupadd -r %{name}
getent passwd %{name} >/dev/null || useradd -r -g %{name} -d %{_sharedstatedir}/%{name} \
	-s /sbin/nologin -c "fleet user" %{name}

%post
%systemd_post %{name}.service

%preun
%systemd_preun %{name}.service

%postun
%systemd_postun %{name}.service

%files
%config(noreplace) %{_sysconfdir}/%{name}
%{_bindir}/%{name}d
%{_bindir}/%{name}ctl
%dir %attr(-,%{name},%{name}) %{_sharedstatedir}/%{name}
%{_unitdir}/%{name}.service
%{_unitdir}/%{name}.socket
%doc LICENSE README.md

%changelog
* Sun Mar 29 2015 Simon Peeters <simon@inuits.eu> - 0.9.1-0.1
- initial build. based on etcd spec file

